import datetime
import hdfs
from pathkit.base import BasePath as BasePath, retry as retry
from typing import Any, Generator

class HDFSPath(BasePath):
    _section = ("hdfs",)
    _creator = hdfs.InsecureClient
    client: hdfs.InsecureClient
    @property
    def exists(self) -> bool: ...
    def is_dir(self) -> bool: ...
    def read(self, shell: bool = False) -> bytes: ...
    def write(self, data: bytes) -> None: ...
    def upload(self, local_path: str) -> None: ...
    def delete(self) -> None: ...
    def mkdir(self) -> None: ...
    def glob(self, pattern: str = '*') -> Generator['HDFSPath', Any, Any]: ...
    @property
    def mtime(self) -> datetime.datetime: ...
    def rglob_in_shell(self, pattern: str = '.') -> list[dict[str, datetime.datetime | str]]: ...
